/*
 *   Autosplitter and Loadless Remover done by TDOG20
 */

state("speed", "v1.2") 
{
    //Describes the loading screen state
    int loadingScreen1 : "speed.exe", 0x510ED0;
    int loadingScreen2 : "speed.exe", 0x5112D0;

    //Displays the current blacklist member
	int blacklistNumber : "speed.exe", 0x51B9FC;

    //Displays the current state of the game and also helps with the loadless timer
	int gamestateID : "speed.exe" , 0x51CCB4;

    //Displays the currently shown FMV and NIS cutscene (loading wise)
    int moviesID : "speed.exe", 0x50FE8C, 0xC;
}

state("speed", "v1.3")
{
    int loadingScreen1 : "speed.exe", 0x511F10;
    int loadingScreen2 : "speed.exe", 0x512310;

	int blacklistNumber : "speed.exe", 0x51CA3C;	 
	
    int gamestateID : "speed.exe", 0x51DCF4;		
    
    int moviesID : "speed.exe", 0x510ECC, 0xC;
}

init
{
    //Original 1.2 speed.exe
    if(modules.First().ModuleMemorySize == 0x67F000)
	{
		version = "v1.2";
	}
    //Original 1.3 speed.exe
    else if(modules.First().ModuleMemorySize == 0x680000)
	{
		version = "v1.3";
	}
    //Cracked 1.3 speed.exe (RELOADED)
    else if(modules.First().ModuleMemorySize == 0x678E4E)
    {
        version = "v1.3";
    }
}

startup
{
    refreshRate = 30;
}

update 
{
    if(version == "") {
        return false;
    }
}

isLoading
{
    //Every normal loading screen
    if(current.loadingScreen1 == 32767 || current.loadingScreen2 == 24 || current.loadingScreen2 == 0 || current.gamestateID == 16) {
        return true;
    }
    //Special loading screen being: going to the safehouse with the golf and leaving the tuning shop for the first time
    else if(current.gamestateID == 32) {
        //Exclude FMVs from being counted to loadless
        if(current.loadingScreen2 == 34) {
            return false;
        }
        else {
            return true;
        }
    }
    else {
        return false;
    }
}

start 
{
    //Decided to leave that free to the players, since 1.2 and 1.3 have different starting points
}

split
{
	//Prologue split
    if(old.gamestateID == 1214 && current.gamestateID == 404) {
		return true;
	}
	//Boss splits
    else if(current.blacklistNumber != old.blacklistNumber && current.blacklistNumber != 15  && old.blacklistNumber != 0) {
		//Preventing splitting when changing blacklist members in the safehouse or when the blacklist menu in free roam is open
        if(old.blacklistNumber > current.blacklistNumber && current.gamestateID != 159 && current.gamestateID != 543) {
            return true;
        }
        else {
            return false;
        }
	}
	//Razor Split
    else if(old.moviesID != current.moviesID && current.moviesID == 1869894492) {
        return true;
    }
    //Final Bridge Jump
    else if(old.moviesID != current.moviesID && current.moviesID == 1381189966) {
        return true;
    }
	else {
		return false;
	}
}

exit
{
    timer.IsGameTimePaused = false;
}